CMAKE_MINIMUM_REQUIRED(VERSION 2.8.5 FATAL_ERROR)
PROJECT(hphp C CXX ASM)

set(HHVM_DEFINITIONS "HAVE_LIBDL;PHP_MYSQL_UNIX_SOCK_ADDR=\"/dev/null\";HAVE_CURL_MULTI_WAIT;U_USING_ICU_NAMESPACE=1;USE_JEMALLOC=1;NO_TCMALLOC=1;OPENSSL_NO_RAND_EGD;USE_EDITLINE;LIBDWARF_CONST_NAME;HAVE_ELF_GETSHDRSTRNDX;HHVM;HAVE_FT2BUILD;HAVE_JSONC;JSONC_INCLUDE_WITH_C;THRIFT_MUTEX_EMULATE_PTHREAD_TIMEDLOCK;HHVM_DYNAMIC_EXTENSION_DIR=\"/usr/lib/x86_64-linux-gnu/hhvm/extensions\";_REENTRANT=1;_PTHREADS=1;__STDC_FORMAT_MACROS;_GNU_SOURCE;RELEASE=1;NDEBUG;ENABLE_FASTCGI=1;HPHP_OSS=1;PACKAGE=hhvm;PACKAGE_VERSION=Release;DEFAULT_CONFIG_DIR=\"/etc/hhvm/\";HAVE_INTTYPES_H;USE_CMAKE;HAVE_LIBBZIP2;HAVE_LIBCURL;HAVE_LIBXML2;HAVE_LIBICU;HAVE_LIBFREETYPE;HAVE_GD_FREETYPE;ENABLE_GD_TTF;HAVE_LIBJPEG;HAVE_GD_JPG;HAVE_ICONV;HAVE_LIBICONV;HAVE_LIBPNG;HAVE_GD_PNG;PNG_SKIP_SETJMP_CHECK;HAVE_LIBVPX;HAVE_LIBINTL;HAVE_LIBGMP;HAVE_LIBMAGICKWAND;HAVE_LIBCCLIENT;HAVE_LIBJSONC;HAVE_LIBLDAP;HAVE_LIBMCRYPT;HAVE_LIBMEMCACHED;ENABLE_ASYNC_MYSQL=1;HAVE_LIBUODBC;HAVE_LIBEXPAT;HAVE_LIBXSLT;FOLLY_HAVE_MALLOC_H=1;FOLLY_NO_CONFIG=1;FOLLY_HAVE_PTHREAD=1;FOLLY_HAVE_CLOCK_GETTIME=1;FOLLY_HAVE_PTHREAD_ATFORK=1;FOLLY_HAVE_PTHREAD_SPINLOCK_T=1;FOLLY_HAVE_FEATURES_H=1;FOLLY_HAVE_LIBDWARF_DWARF_H=1;FOLLY_HAVE_VLA=1;FOLLY_HAVE_IFUNC=0;FOLLY_HAVE_BITS_FUNCTEXCEPT_H=1;FOLLY_HAVE_LINUX_MEMBARRIER_H=1;FOLLY_HAVE_WEAK_SYMBOLS=1;FOLLY_HAVE_MEMRCHR=1;FOLLY_HAVE_PREADV=1;FOLLY_HAVE_PWRITEV=1;FOLLY_HAVE_LIBGFLAGS=0;NO_LIB_GFLAGS")
set(HHVM_VERSION_BRANCH "32112")
set(CMAKE_INSTALL_PREFIX "/usr")
set(CMAKE_INSTALL_LIBDIR "lib/x86_64-linux-gnu")
set(CMAKE_BUILD_TYPE "RelWithDebInfo")
set(ENABLE_ZEND_COMPAT "ON")

option(HHVM_DSO_TEST_MODE "Build against source headers, not installed ones" Off)
if (HHVM_DSO_TEST_MODE)
  set(HHVM_INCLUDE_DIRS "/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg;/usr/include;/usr/include/x86_64-linux-gnu;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/squangle/src;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/webscalesqlclient/src/include;/usr/include/libxml2;/usr/include/double-conversion;/usr/lib/x86_64-linux-gnu/libzip/include;/usr/include/libdwarf;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/hphp;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/libmbfl;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/libmbfl/mbfl;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/libmbfl/filters;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/timelib;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/folly/src;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/fatal;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/wangle/src;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/brotli/src;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/proxygen/src;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/thrift/src;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/zstd/src/lib;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/zstd/src/lib/dictBuilder;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/libafdt/src/src;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/mcrouter/src;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/fastlz/src;/usr/include/freetype2;/usr/include/vpx;/usr/include/ImageMagick-6;/usr/include/x86_64-linux-gnu/ImageMagick-6;/usr/include/c-client;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/squangle/src/;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/webscalesqlclient/src/include/;/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/third-party/folly")
  set(CMAKE_MODULE_PATH
    ${CMAKE_CURRENT_SOURCE_DIR}
    "/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/CMake" "/build/hhvm-U1jBhB/hhvm-3.24.7+dfsg/hphp/public_tld/CMake"
    ${CMAKE_MODULE_PATH})
else()
  set(HHVM_INCLUDE_DIRS "/usr/include;/usr/include;/usr/include/x86_64-linux-gnu;/usr/include/hphp/third-party/squangle/src;/usr/include/hphp/third-party/webscalesqlclient/src/include;/usr/include/libxml2;/usr/include/double-conversion;/usr/lib/x86_64-linux-gnu/libzip/include;/usr/include/libdwarf;/usr/include/hphp;/usr/include/hphp/third-party;/usr/include/hphp/third-party/libmbfl;/usr/include/hphp/third-party/libmbfl/mbfl;/usr/include/hphp/third-party/libmbfl/filters;/usr/include/hphp/third-party/timelib;/usr/include/hphp/third-party/folly/src;/usr/include/hphp/third-party/fatal;/usr/include/hphp/third-party/wangle/src;/usr/include/hphp/third-party/brotli/src;/usr/include/hphp/third-party/proxygen/src;/usr/include/hphp/third-party/thrift/src;/usr/include/hphp/third-party/zstd/src/lib;/usr/include/hphp/third-party/zstd/src/lib/dictBuilder;/usr/include/hphp/third-party/libafdt/src/src;/usr/include/hphp/third-party/mcrouter/src;/usr/include/hphp/third-party/fastlz/src;/usr/include/freetype2;/usr/include/vpx;/usr/include/ImageMagick-6;/usr/include/x86_64-linux-gnu/ImageMagick-6;/usr/include/c-client;/usr/include/hphp/third-party/squangle/src/;/usr/include/hphp/third-party/webscalesqlclient/src/include/")
  set(CMAKE_MODULE_PATH
    ${CMAKE_CURRENT_SOURCE_DIR}
    "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/hhvm/CMake"
    ${CMAKE_MODULE_PATH})
endif()

message(STATUS "Configuring for HHVM API version ${HHVM_VERSION_BRANCH}")

include(HPHPFunctions)
include(HPHPIZEFunctions)
include(HPHPCompiler)
include(config)

foreach (dir ${HHVM_INCLUDE_DIRS})
  include_directories(${dir})
endforeach()

add_definitions("-DHHVM_BUILD_DSO")
foreach (def ${HHVM_DEFINITIONS})
  add_definitions("-D${def}")
endforeach()

add_custom_target(test COMMAND
                       HHVM_BIN=${CMAKE_INSTALL_PREFIX}/bin/hhvm
                       ${CMAKE_CURRENT_SOURCE_DIR}/run-test
                       -a "-vDynamicExtensions.99=${EXTENSION_NAME}.so" test
                       DEPENDS ${EXTENSION_NAME})
